#ifndef _WISIO_H_
#define _WISIO_H_ 1
#include <features.h>
#define byte unsigned char
#define word unsigned short
#define dword unsigned int

extern Wloglevel;
#define STRUCTSIZE(sct,fld) (sizeof(sct.fld)+(int)&sct.fld-(int)&sct)
#define CLEAR(x) memset(&(x),0,sizeof(x))
#define PEND     -1 
#define ENDD     0x7fff4a71 

#define MAXDIMVAL 16000
#define MAXIDX    16000
#define MAXPS     256
#define MAXWAITTIME 16000000
#define MAXCTRL   4096
#define MAXITEMS  2048 
#define MAXCMDDIM 16

#define BASEQUE     1024                 /* First real queue number (=0)*/
#define MAINQUE     1                    /* Queue for wisio server      */   
#define STARTQUE    0                    /* When starting process queue where to receive own queue number */
#define LOADERQUEUE 2                    
#define WIN_QUE     1025                 /* Real queue of wisio server   */
#define MAINCID     1                    /* Base cid of all controls     */

/* COMMANDS TYPES  */
#define MSG_TYPALL  0                    /* To receive all               */
#define MSG_TYPCMD  1                    /* Command type                 */
#define MSG_TYPRET  2                    /* Only to receive return value of command*/
#define MSG_TYPPTR  3                    /* Command type for mouse device  */
#define MSG_TYPKEY  4                    /* Command type for keyboard    */
#define MSG_TYPDIM  8                    /* Command type with dimensio   */

/* COMMANDS */
                                           /* Control handling  */
#define CMD_ADDCTL  0x30              
#define CMD_INICTL  0x31
#define CMD_GETCTL  0x32
#define CMD_ACTCTL  0x33
#define CMD_UPDCTL  0x34
#define CMD_PUTCTL  0x35
#define CMD_SELCTL  0x36
#define CMD_DELCTL  0x37
#define CMD_TOPCTL  0x38
#define CMD_REQCTL  0x3E                                           
#define CMD_SETCTL  0x3F
                                               /* Text and bitmaps */
#define CMD_ADDTXT  0x40
#define CMD_PUTTXT  0x41
                                               /* Area filling */
#define CMD_ADDBAR  0x50
#define CMD_PUTBAR  0x51
#define CMD_DELBAR  0x57
                                               
#define CMD_ADDTRI  0x5E
                                               
#define CMD_ADDLIN  0x60                                               
                                               /* Return messages */
#define CMD_RETVAL  0x80
#define CMD_RETCTL  0x83
                                                                                              
#define CMD_ENDWIN  0x90
#define CMD_SETWIN  0x9F                                               
                                               /* Task  commands  */
#define CMD_ADDTSK  0x100
#define CMD_PUTTSK  0x101
#define CMD_DELTSK  0x107
#define CMD_SETTSK  0x10F
                                               /* Bitmap commands */
#define CMD_GETBTM  0x110
#define CMD_ADDBTM  0x120
#define CMD_PUTBTM  0x121
                                               /* Mouse commands */
#define CMD_UPDPTR  0x200
#define CMD_TRCPTR  0x207
                                               /* Keyboard commands  */
#define CMD_ADDKEY  0x210
#define CMD_TRCKEY  0x217

#define CMD_ADDCLK  0x220
#define CMD_PUTCUR  0x231
#define CMD_LOOP    0x300

#define CMD_APPMSG  0x1000

#define MES_RET_SIZ  16

#define WBTP_CO1  0
#define WBTP_CO2  1
#define WBTP_CO4  2
#define WBTP_CO16 3
#define WBTP_CO256 4
#define WBTP_CO64k 5
#define WBTP_CO32M 6
#define WBTP_COMAX  7
#define WBTP_COMASK 7

#define WIN_CTRL  16
#define WINC_TRANS 1

#define  GETCTL_PREV   0
#define  GETCTL_NEXT   1
#define  GETCTL_PARENT 2
#define  GETCTL_CHILD  3
#define  GETCTL_TASK   0x20

#define  SETCTL_UNDEF0 0                 /* Value no more used  (*_PREV)*/
#define  SETCTL_UNDEF1 1                 /* Value no more used  (*_NEXT)*/ 

#define  SETCTL_WINPOS    0x10           /* Set view position in window */
#define  SETCTL_SIZE      0x11
#define  SETCTL_ALIGN     0x12           /* Set view position with align */
#define  SETCTL_COLOR_D   0x20           /* Set color direct            */
#define  SETCTL_BGCOLOR_D 0x21           /* Set background color direct */
#define  SETCTL_BTM       0x30           /* Set default ctrl font       */
#define  SETCTL_POS       0x40
#define  SETCTL_CURPOS    0x40
#define  SETCTL_PREV      0x100
#define  SETCTL_NEXT      0x101
#define  SETCTL_ORDER     0x102
#define IS_CTRL(x) (x&WIN_CTRL)

/* Align defines : SETCTL_ALIGN  Values can be combined with OR (|)*/
#define  ALIGN_LEFT      1      
#define  ALIGN_RIGHT     2
#define  ALIGN_HCENTER   3
#define  ALIGN_TOP       4
#define  ALIGN_BOTTOM    8
#define  ALIGN_VCENTER  12


/* Structure is no more static see comments in right side        */
/* All field are no more accessible with direct record structure */ 
#define MAX_MSG_TEXT 256
typedef struct
{
      long int des;                       /* Msg level                                 */
      long int pid;                       /* Sender id                                 */
      short cmd;                          /* Message type                              */
      short cid;                          /* Control id assiged with message           */
      short idx;                          /* Used as number of index fields in args    */
      short flg;                          /* Message flg  Wgetdim(msg,0)               */
      short x,y,dx,dy;                    /* Accessed with Wgetdim(msg,1..15) function */
      int   co1,co2;                      /* Not used                                  */
      byte  data[MAX_MSG_TEXT];           /* Accessed with Wgetdata(..) function       */
}
msg_win_cmd;

#define BMT_IDENT 0x57426d74 
typedef struct
{
    int ident,
        size,
        bits,
        bitmaps,
        width,
        height,
        bytes,
        colors,
        trans,
        start,
        widths,
        heights;
   byte bmdata[0];
}
tbitmaptbl;

    
extern mypid;
extern int *queues;
extern int loaderqueue;

#define TSK_END      0
#define TSK_START    1
#define TSK_SINGLE   2
#define TSK_MULTI    4
#define TSK_UNIQUE   8
#define TSK_FIND    64
#ifdef __cplusplus
extern "C"
{
#endif
/* wlib.c */
int add_text(int cmd, int cid, int idx, int flag, int x, int y, int dx, int dy, int co, char *data);
int Wadd_text(int pid, int cid, int idx, int flag, int x, int y, int dx, int dy, int co, int co2, char *data);
int Waddtext(int cid, int flag, int x, int y, char *str);
int create_ctrl(int des, int cid, int idx, int flag, int x, int y, int dx, int dy, int size);
int Wadd_ctrl(int des, int cid, int flag, int x, int y, int dx, int dy, int size, int co2, void *data, int datalen);
int Waddctl(int cid, int flag, int x, int y, int dx, int dy);
int Wcreate_ctrl(int des, int cid, int flag, int x, int y, int dx, int dy, int size, void *data);
int Wput_ctrl(int des, int cid, int flag, int x, int y, int dx, int dy);
int Wset_ctrl(int des, int cid, int flag, int x, int y);
int Wsetctl(int cid, int flag, int arg1, int arg2);
int Wsetctl4(int cid, int flag, int arg1, int arg2, int arg3, int arg4);
int Wputn_ctrl(int des, int cid, int flag, int x, int y, int dx, int dy, int co1, int co2, char *data, int datalen);
int Wgetbm(void *data);
int Wgetctrl(int cid, int flag);
int Wupdate_ctrl(int cid, int pid, char *data, int len);
int add_rect(int cmd, int cid, int idx, int x, int y, int dx, int dy, int co);
int Wadd_bar(int cid, int font, int x, int y, int dx, int dy, int chr);
int Waddbar(int cid, int font, int x, int y, int dx, int dy, int chr);
int Wdelbar(int cid, int x, int y, int dx, int dy);
int Wadd_btm(int cid, int bits, int x, int y, int dx, int dy, int color);
int Wput_btm(int btm, int x, int y, int dx, int dy, int color, char *bm, int bytes);
int Wdel_ctrl(int des, int cid, int idx, int len);
int Wact_ctrl(int cid, int flg);

/* wmio.c */
int Wlog(int level, char *format, ...);
int Wsend(int pid, msg_win_cmd *pmes, int len);
int Wsendcmd(int des, ...);
int Wsendncmd(int des, int cmd, int cid, int idx, int flg, int x, int y, int dx, int dy, int co1, int co2, char *data, int datalen);
int Wretval(int pid, int cid, int idx);
int Wsenddim(int des, int cmd, int cid, ...);
int Wsenddat(int des, int cmd, int cid, char *data, int datalen, ...);
int Wsendmsg(int des, int cmd, int cid, int flg, int dim[], int dims, char *data, int datalen);
int Wretmsg(int cmd, int pid, int cid);
int Wrecval(int cmd);
int Wgetdim(msg_win_cmd *pmes, int idx);
void *Wgetdata(msg_win_cmd *pmes, int *len);
int Wgetcmd(msg_win_cmd *mes);
int Wgetretval(void);
int Wdefault_msg(msg_win_cmd *pmes);
int win_init(void);
int Wopenobj(char *str);
int Wqopen(int pid);
int Wdelque(int pid);
int Wqueinit(void);
int Wsetpar(int parametr, int value);


#ifdef __cplusplus 
}
#endif
#define  PAR_MSGTYPE    1
#define  PAR_TIMER      2
#define  PAR_RETRY      3
#define  PAR_SENDLEVEL  4
#define  PAR_RECVLEVEL  1

/* keyboad flags */
#define SHIFT_KFL      0x1             
#define CTRL_KFL       0x2            
#define ALT_KFL        0x4
#define ALTG_KFL       0x8
#define CAPS_KFL       0x10
#define NUM_KFL        0x20
#define SCR_KFL        0x40
#define PRESS_KFL      0x80

#define ASC_KFL        0x000
#define CUR_KFL        0x100
#define FUN_KFL        0x200
#define CTL_KFL        0x300
#define INS_KFL        0x400
#define SEC_KFL        0x8000

/* KEYBOARD CODES  */
#define BS_KEY 8
#define TAB_KEY 9
#define ENTER_KEY 13
#define ESC_KEY 27
#define SPACE_KEY 32

#define DEL_KEY    0x2E00
#define INS_KEY    0x3000
#define END_KEY    0x3100
#define DOWN_KEY   0x3200
#define PGDN_KEY   0x3300
#define LEFT_KEY   0x3400
#define RIGHT_KEY  0x3600
#define HOME_KEY   0x3700
#define UP_KEY     0x3800
#define PGUP_KEY   0x3900

/* Video driver commands */
#define GRD_INFO       0x00
#define GRD_MODE       0x01
#define GRD_DRAW       0x02
#define GRD_READ       0x03
#define GRD_TERM       0x04
#define GRD_TRIA       0x05
#define GRD_SHAPE      0x06
#define GRD_MAX        0x10



#define CTRL_HORISONT   0x01
#endif

